Jury Compromise
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 33737   Accepted: 9109   Special Judge

Description

In Frobnia, a far-away country, the verdicts in court trials are determined by a jury consisting of members of the general public. Every time a trial is set to begin, a jury has to be selected, which is done as follows. First, several people are drawn randomly from the public. For each person in this pool, defence and prosecution assign a grade from 0 to 20 indicating their preference for this person. 0 means total dislike, 20 on the other hand means that this person is considered ideally suited for the jury. 
Based on the grades of the two parties, the judge selects the jury. In order to ensure a fair trial, the tendencies of the jury to favour either defence or prosecution should be as balanced as possible. The jury therefore has to be chosen in a way that is satisfactory to both parties. 
We will now make this more precise: given a pool of n potential jurors and two values di (the defence's value) and pi (the prosecution's value) for each potential juror i, you are to select a jury of m persons. If J is a subset of {1,..., n} with m elements, then D(J ) = sum(dk) k belong to J 
and P(J) = sum(pk) k belong to J are the total values of this jury for defence and prosecution. 
For an optimal jury J , the value |D(J) - P(J)| must be minimal. If there are several jurys with minimal |D(J) - P(J)|, one which maximizes D(J) + P(J) should be selected since the jury should be as ideal as possible for both parties. 
You are to write a program that implements this jury selection process and chooses an optimal jury given a set of candidates.

Input

The input file contains several jury selection rounds. Each round starts with a line containing two integers n and m. n is the number of candidates and m the number of jury members. 
These values will satisfy 1<=n<=200, 1<=m<=20 and of course m<=n. The following n lines contain the two integers pi and di for i = 1,...,n. A blank line separates each round from the next. 
The file ends with a round that has n = m = 0.

Output

For each round output a line containing the number of the jury selection round ('Jury #1', 'Jury #2', etc.). 
On the next line print the values D(J ) and P (J ) of your jury as shown below and on another line print the numbers of the m chosen candidates in ascending order. Output a blank before each individual candidate number. 
Output an empty line after each test case.

Sample Input

4 2
1 2
2 3
4 1
6 2
0 0

Sample Output

Jury #1
Best jury has value 6 for prosecution and value 4 for defence:
2 3

Hint

If your solution is based on an inefficient algorithm, it may not execute in the allotted time.

Source

 
题意:
从n个人中选m个人,要求sum1-sum2最小,sum1+sum2最大.
思路:
现用dp(j, k)表示,取j 个候选人,使其辩控差为k 的所有方案中,辩控和最大的那个方案(该方案称为“方案dp(j, k)”)的辩控和。
可行方案dp(j-1, x)能演化成方案dp(j, k)的必要条件是:存在某个候选人i,i 在方案dp(j-1, x)中没有被选上,且x+V(i) = k。在所有满足该必要条件的dp(j-1, x)中,选出 dp(j-1, x) + S(i) 的值最大的那个,那么方案dp(j-1, x)再加上候选人i,就演变成了方案 dp(j, k)。
 
#include<iostream>
#include<algorithm>
#include<vector>
#include<stack>
#include<queue>
#include<map>
#include<set>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<ctime>
#define fuck(x) cout<<#x<<" = "<<x<<endl;
#define ls (t<<1)
#define rs ((t<<1)+1)
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int maxn = ;
const int inf = 2.1e9;
const ll Inf = ;
const int mod = ;
const double eps = 1e-;
const double pi = acos(-);
int n,m;
int dp[][];
int num1[],num2[],sum[],diff[];
int path[][];
int fix = ; bool check(int i,int k,int j){
while(i&&path[i][k]!=j){
k-=diff[path[i][k]];
i--;
}
return i==;
} int main()
{
// ios::sync_with_stdio(false);
// freopen("in.txt","r",stdin);
int cases=;
while(scanf("%d%d",&n,&m)!=EOF&&(n||m)){
vector<int>ans;
for(int i=;i<=n;i++){
scanf("%d%d",&num1[i],&num2[i]);
sum[i]=num1[i]+num2[i];
diff[i]=num1[i]-num2[i];
}
memset(dp,-,sizeof(dp)); dp[][fix]=;
for(int i=;i<=m;i++){
for(int k=;k<=*fix;k++){
if(dp[i-][k]<){continue;}
for(int j=;j<=n;j++){
if(dp[i][k+diff[j]]<dp[i-][k]+sum[j]&&check(i-,k,j)){
dp[i][k+diff[j]]=dp[i-][k]+sum[j];
path[i][k+diff[j]]=j;
}
}
}
}
int minn=,maxx=;
for(int i=;i<=fix;i++){
// cout<<dp[m][fix-i];
if(dp[m][fix-i]>=||dp[m][fix+i]>=){
minn=i;break;
}
}
int rec=;
if(dp[m][fix-minn]>dp[m][fix+minn]){
rec=fix-minn;
maxx=dp[m][fix-minn];
}
else{
rec=fix+minn;
maxx=dp[m][fix+minn];
}
int ans1,ans2;
ans1=ans2=;
while(m){
ans.push_back(path[m][rec]);
ans1+=num1[path[m][rec]];
ans2+=num2[path[m][rec]];
rec-=diff[path[m][rec]];
m--;
}
cases++;
printf("Jury #%d\n",cases);
printf("Best jury has value %d for prosecution and value %d for defence:\n",ans1,ans2);
sort(ans.begin(),ans.end());
int sz=ans.size();
for(int i=;i<sz;i++){
printf(" %d",ans[i]);
}
printf("\n\n");
} return ;
}

最新文章

  1. UEditor编辑器使用示例
  2. Java内存与垃圾收集知识总结
  3. IOS-App installation failed原因及解决方法
  4. init_MUTEX 与 sema_init 函数【转】
  5. 通过CoreImage生成二维码
  6. c# 调用 ShellExecute
  7. hdu-5701 中位数计数(中位数)
  8. 【原】Storm Tutorial
  9. python(3)-队列
  10. MYSQL 系统命令 源码定位
  11. 设计模式六大原则(2):里氏替换原则(Liskov Substitution Principle)
  12. UVA 10404 Bachet&#39;s Game(dp + 博弈?)
  13. react中,constructor和getInitialState的区别
  14. Kafka的生产者和消费者代码解析
  15. isinstance与type的区别
  16. 05-python基础
  17. xdebug 安装及使用规则
  18. Spring 父子容器
  19. CSS3 Flex Box(弹性盒子)
  20. Leetcode 557. 反转字符串中的单词 III

热门文章

  1. FFmpeg AVPacket相关主要函数介绍
  2. Server/Service/Engine/Host/Context} Setting property &#39;source&#39; to &#39;org.eclipse.jst.jee
  3. 使用VsCode自带的Emmet语法
  4. 【转载】FPGA算法设计随笔
  5. 关于Java中IO流的练习
  6. 英语口语练习系列-C19-喜欢某人
  7. 【spring源码分析】准备工作
  8. ElasticSearch(八):elasticsearch.yml配置说明
  9. SQL LCASE() 函数
  10. 前端学习-基础部分-css(二)